﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using NQueries.Data.Queries;
using TestModel;

namespace TestConsole
{
    public class QueryAllProducts : Query<IAdventureWorksEntities, IEnumerable<Product>>
    {
        protected override Expression<Func<IAdventureWorksEntities, IEnumerable<Product>>> Expression
        {
            get
            {
                return (context) => from product in context.Products.OfType<Product>()
                                    where product.Name.StartsWith("a")
                                    orderby product.Name
                                    select product;
            }
        }
    }
}