﻿using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Runtime.Serialization;

namespace NQueries
{
    /// <summary>
    /// Exception generated by NQueries.
    /// </summary>
    [Serializable]
    public class NQueriesException : Exception
    {
        /// <summary>
        /// Constructor.
        /// </summary>
        [DebuggerNonUserCode]
        public NQueriesException() { }

        /// <summary>
        /// Constructor.
        /// </summary>
        /// <param name="message"></param>
        [DebuggerNonUserCode]
        public NQueriesException([Localizable(false)] string message)
            : base(message) { }

        /// <summary>
        /// Constructor.
        /// </summary>
        /// <param name="message"></param>
        /// <param name="innerException"></param>
        [DebuggerNonUserCode]
        public NQueriesException([Localizable(false)] string message, Exception innerException)
            : base(message, innerException) { }

        /// <summary>
        /// Constructor.
        /// </summary>
        /// <param name="info"></param>
        /// <param name="context"></param>
        [DebuggerNonUserCode]
        protected NQueriesException(SerializationInfo info, StreamingContext context) : base(info, context) { }
    }
}