using System.Globalization;

namespace NQueries.Utils
{
    /// <summary>
    /// Contains various extension methods for the string type.
    /// </summary>
    internal static class StringExtensions
    {
        /// <summary>
        /// Formats the string with the given parameters using an invariant <see cref="CultureInfo"/>
        /// </summary>
        /// <param name="format"></param>
        /// <param name="args"></param>
        /// <returns></returns>
        public static string FormatWith(this string format, params object[] args) { return string.Format(CultureInfo.InvariantCulture, format, args); }
    }
}